jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
| 20 | while [ -h "${prog}" ]; do |
| 21 | newProg=`/bin/ls -ld "${prog}"` |
| 22 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 23 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 24 | prog="${newProg}" |
| 25 | else |
| 26 | progdir=`dirname "${prog}"` |
| 27 | prog="${progdir}/${newProg}" |
| 28 | fi |
| 29 | done |
| 30 | oldwd=`pwd` |
| 31 | progdir=`dirname "${prog}"` |
| 32 | cd "${progdir}" |
| 33 | progdir=`pwd` |
| 34 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 35 | test_dir="test-$$" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 36 | tmp_dir="/tmp/$USER/${test_dir}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 37 | |
| 38 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 39 | export JAVAC="javac -g" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 40 | export RUN="${progdir}/etc/push-and-run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 41 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 42 | export NEED_DEX="true" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 44 | # If dx was not set by the environment variable, assume it is in the path. |
| 45 | if [ -z "$DX" ]; then |
| 46 | export DX="dx" |
| 47 | fi |
| 48 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 49 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 50 | if [ -z "$JASMIN" ]; then |
| 51 | export JASMIN="jasmin" |
| 52 | fi |
| 53 | |
| 54 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 55 | info="info.txt" |
| 56 | build="build" |
| 57 | run="run" |
| 58 | expected="expected.txt" |
| 59 | output="output.txt" |
| 60 | build_output="build-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 61 | lib="libartd.so" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 62 | run_args="--quiet" |
| 63 | |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 64 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 65 | dev_mode="no" |
| 66 | update_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 67 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 68 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 69 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 70 | suffix64="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 71 | |
| 72 | while true; do |
| 73 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 74 | target_mode="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 75 | RUN="${progdir}/etc/host-run-test-jar" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 76 | DEX_LOCATION=$tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 77 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 78 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 79 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 80 | runtime="jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 81 | RUN="${progdir}/etc/reference-run-test-classes" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 82 | NEED_DEX="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 83 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 84 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 85 | lib="libart.so" |
| 86 | shift |
| 87 | elif [ "x$1" = "x--dalvik" ]; then |
| 88 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 89 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 90 | shift |
| 91 | elif [ "x$1" = "x--image" ]; then |
| 92 | shift |
| 93 | image="$1" |
| 94 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 95 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 96 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 97 | shift |
| 98 | option="$1" |
| 99 | run_args="${run_args} -Xcompiler-option $option" |
| 100 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 101 | elif [ "x$1" = "x--runtime-option" ]; then |
| 102 | shift |
| 103 | option="$1" |
| 104 | run_args="${run_args} --runtime-option $option" |
| 105 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 106 | elif [ "x$1" = "x--debug" ]; then |
| 107 | run_args="${run_args} --debug" |
| 108 | shift |
| 109 | elif [ "x$1" = "x--gdb" ]; then |
| 110 | run_args="${run_args} --gdb" |
| 111 | dev_mode="yes" |
| 112 | shift |
| 113 | elif [ "x$1" = "x--zygote" ]; then |
| 114 | run_args="${run_args} --zygote" |
| 115 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 116 | elif [ "x$1" = "x--interpreter" ]; then |
| 117 | run_args="${run_args} --interpreter" |
| 118 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 119 | elif [ "x$1" = "x--no-verify" ]; then |
| 120 | run_args="${run_args} --no-verify" |
| 121 | shift |
| 122 | elif [ "x$1" = "x--no-optimize" ]; then |
| 123 | run_args="${run_args} --no-optimize" |
| 124 | shift |
| 125 | elif [ "x$1" = "x--no-precise" ]; then |
| 126 | run_args="${run_args} --no-precise" |
| 127 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 128 | elif [ "x$1" = "x--invoke-with" ]; then |
| 129 | shift |
| 130 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 131 | if [ "x$what" = "x" ]; then |
| 132 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 133 | usage="yes" |
| 134 | break |
| 135 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 136 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 137 | shift |
| 138 | elif [ "x$1" = "x--dev" ]; then |
| 139 | run_args="${run_args} --dev" |
| 140 | dev_mode="yes" |
| 141 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 142 | elif [ "x$1" = "x--build-only" ]; then |
| 143 | build_only="yes" |
| 144 | shift |
| 145 | elif [ "x$1" = "x--output-path" ]; then |
| 146 | shift |
| 147 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 148 | if [ "x$tmp_dir" = "x" ]; then |
| 149 | echo "$0 missing argument to --output-path" 1>&2 |
| 150 | usage="yes" |
| 151 | break |
| 152 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 153 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 154 | elif [ "x$1" = "x--update" ]; then |
| 155 | update_mode="yes" |
| 156 | shift |
| 157 | elif [ "x$1" = "x--help" ]; then |
| 158 | usage="yes" |
| 159 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 160 | elif [ "x$1" = "x--64" ]; then |
| 161 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 162 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 163 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 164 | elif [ "x$1" = "x--trace" ]; then |
| 165 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 166 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 167 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 168 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 169 | usage="yes" |
| 170 | break |
| 171 | else |
| 172 | break |
| 173 | fi |
| 174 | done |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 175 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 176 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 177 | if [ ! "$runtime" = "jvm" ]; then |
| 178 | run_args="${run_args} --lib $lib" |
| 179 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 180 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 181 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 182 | if [ "$target_mode" = "no" ]; then |
| 183 | framework="${OUT}/system/framework" |
| 184 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 185 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 186 | else |
| 187 | true # defaults to using target BOOTCLASSPATH |
| 188 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 189 | elif [ "$runtime" = "art" ]; then |
| 190 | if [ "$target_mode" = "no" ]; then |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 191 | # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment. |
| 192 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 193 | export ANDROID_BUILD_TOP=$oldwd |
| 194 | fi |
| 195 | if [ -z "$ANDROID_HOST_OUT" ]; then |
| 196 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
| 197 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 198 | run_args="${run_args} --boot -Ximage:${ANDROID_HOST_OUT}/framework/core.art" |
| 199 | else |
Brian Carlstrom | 0e12bdc | 2014-05-14 17:44:28 -0700 | [diff] [blame] | 200 | run_args="${run_args} --boot -Ximage:/data/art-test/core.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 201 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 202 | fi |
| 203 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 204 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 205 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 206 | usage="yes" |
| 207 | fi |
| 208 | |
| 209 | if [ "$usage" = "no" ]; then |
| 210 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 211 | test_dir=`basename "$oldwd"` |
| 212 | else |
| 213 | test_dir="$1" |
| 214 | fi |
| 215 | |
| 216 | if [ '!' -d "$test_dir" ]; then |
| 217 | td2=`echo ${test_dir}-*` |
| 218 | if [ '!' -d "$td2" ]; then |
| 219 | echo "${test_dir}: no such test directory" 1>&2 |
| 220 | usage="yes" |
| 221 | fi |
| 222 | test_dir="$td2" |
| 223 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 224 | # Shift to get rid of the test name argument. The rest of the arguments |
| 225 | # will get passed to the test run. |
| 226 | shift |
| 227 | fi |
| 228 | |
| 229 | if [ "$usage" = "yes" ]; then |
| 230 | prog=`basename $prog` |
| 231 | ( |
| 232 | echo "usage:" |
| 233 | echo " $prog --help Print this message." |
| 234 | echo " $prog [options] [test-name] Run test normally." |
| 235 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 236 | "(dumps to stdout)." |
| 237 | echo " $prog --update [options] [test-name] Update mode" \ |
| 238 | "(replaces expected.txt)." |
| 239 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 240 | "current directory." |
| 241 | echo " Runtime Options:" |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 242 | echo " -O Run non-debug rather than debug build (off by default)." |
| 243 | echo " -Xcompiler-option Pass an option to the compiler." |
Ian Rogers | 701aa64 | 2014-07-18 11:38:13 -0700 | [diff] [blame^] | 244 | echo " --runtime-option Pass an option to the runtime." |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 245 | echo " --debug Wait for a debugger to attach." |
| 246 | echo " --gdb Run under gdb; incompatible with some tests." |
| 247 | echo " --build-only Build test files only (off by default)." |
| 248 | echo " --interpreter Enable interpreter only mode (off by default)." |
| 249 | echo " --no-verify Turn off verification (on by default)." |
| 250 | echo " --no-optimize Turn off optimization (on by default)." |
| 251 | echo " --no-precise Turn off precise GC (on by default)." |
| 252 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 253 | "If used, then the" |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 254 | echo " other runtime options are ignored." |
| 255 | echo " --host Use the host-mode virtual machine." |
| 256 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 257 | echo " --dalvik Use Dalvik (off by default)." |
| 258 | echo " --jvm Use a host-local RI virtual machine." |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 259 | echo " --output-path [path] Location where to store the build" \ |
| 260 | "files." |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 261 | echo " --64 Run the test in 64-bit mode" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 262 | echo " --trace Run with method tracing" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 263 | ) 1>&2 |
| 264 | exit 1 |
| 265 | fi |
| 266 | |
| 267 | cd "$test_dir" |
| 268 | test_dir=`pwd` |
| 269 | |
| 270 | td_info="${test_dir}/${info}" |
| 271 | td_expected="${test_dir}/${expected}" |
| 272 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 273 | if [ ! -r $td_info ]; then |
| 274 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 275 | exit 1 |
| 276 | fi |
| 277 | |
| 278 | if [ ! -r $td_expected ]; then |
| 279 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 280 | exit 1 |
| 281 | fi |
| 282 | |
| 283 | # copy the test to a temp dir and run it |
| 284 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 285 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 286 | |
| 287 | rm -rf "$tmp_dir" |
| 288 | cp -Rp "$test_dir" "$tmp_dir" |
| 289 | cd "$tmp_dir" |
| 290 | |
| 291 | if [ '!' -r "$build" ]; then |
| 292 | cp "${progdir}/etc/default-build" build |
| 293 | fi |
| 294 | |
| 295 | if [ '!' -r "$run" ]; then |
| 296 | cp "${progdir}/etc/default-run" run |
| 297 | fi |
| 298 | |
| 299 | chmod 755 "$build" |
| 300 | chmod 755 "$run" |
| 301 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 302 | export TEST_NAME=`basename ${test_dir}` |
| 303 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 304 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
| 305 | file_size_limit=2048 |
| 306 | if echo "$test_dir" | grep 089; then |
| 307 | file_size_limit=5120 |
| 308 | elif echo "$test_dir" | grep 083; then |
| 309 | file_size_limit=5120 |
| 310 | fi |
| 311 | if ! ulimit "$file_size_limit"; then |
| 312 | echo "ulimit file size setting failed" |
| 313 | fi |
| 314 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 315 | good="no" |
| 316 | if [ "$dev_mode" = "yes" ]; then |
| 317 | "./${build}" 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 318 | build_exit="$?" |
| 319 | echo "build exit status: $build_exit" 1>&2 |
| 320 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 321 | echo "${test_dir}: running..." 1>&2 |
| 322 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 323 | run_exit="$?" |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 324 | echo "run exit status: $run_exit" 1>&2 |
| 325 | if [ "$run_exit" = "0" ]; then |
| 326 | good="yes" |
| 327 | fi |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 328 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 329 | elif [ "$update_mode" = "yes" ]; then |
| 330 | "./${build}" >"$build_output" 2>&1 |
| 331 | build_exit="$?" |
| 332 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 333 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 334 | "./${run}" $run_args "$@" >"$output" 2>&1 |
| 335 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 336 | good="yes" |
| 337 | else |
| 338 | cat "$build_output" 1>&2 |
| 339 | echo "build exit status: $build_exit" 1>&2 |
| 340 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 341 | elif [ "$build_only" = "yes" ]; then |
| 342 | good="yes" |
| 343 | "./${build}" >"$build_output" 2>&1 |
| 344 | build_exit="$?" |
| 345 | if [ "$build_exit" '!=' '0' ]; then |
| 346 | cp "$build_output" "$output" |
| 347 | echo "build exit status: $build_exit" >>"$output" |
| 348 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 349 | if [ "$?" '!=' "0" ]; then |
| 350 | good="no" |
| 351 | echo "BUILD FAILED For ${TEST_NAME}" |
| 352 | fi |
| 353 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 354 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 355 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 356 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 357 | else |
| 358 | "./${build}" >"$build_output" 2>&1 |
| 359 | build_exit="$?" |
| 360 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 361 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 362 | "./${run}" $run_args "$@" >"$output" 2>&1 |
| 363 | else |
| 364 | cp "$build_output" "$output" |
| 365 | echo "build exit status: $build_exit" >>"$output" |
| 366 | fi |
| 367 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 368 | if [ "$?" = "0" ]; then |
| 369 | # output == expected |
| 370 | good="yes" |
| 371 | echo "${test_dir}: succeeded!" 1>&2 |
| 372 | fi |
| 373 | fi |
| 374 | |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 375 | # Clean up test files. |
| 376 | if [ "$good" == "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 377 | cd "$oldwd" |
| 378 | rm -rf "$tmp_dir" |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 379 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 380 | adb shell rm -rf $DEX_LOCATION |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 381 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 382 | exit 0 |
| 383 | fi |
| 384 | |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 385 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 386 | ( |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 387 | if [ "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 388 | echo "${test_dir}: FAILED!" |
| 389 | echo ' ' |
| 390 | echo '#################### info' |
| 391 | cat "${td_info}" | sed 's/^/# /g' |
| 392 | echo '#################### diffs' |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 393 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 500 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 394 | echo '####################' |
| 395 | echo ' ' |
| 396 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 397 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 398 | if [ "$target_mode" == "yes" ]; then |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 399 | echo "and in ${DEX_LOCATION} on target" |
| 400 | fi |
| 401 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 402 | ) 1>&2 |
| 403 | |
| 404 | exit 1 |